# -*- coding: utf-8 -*-
"""

"""

import utsusemi.vis.VisualModuleQBase as UVM

# 予約語の定義
ret = None
vp1 = None
vp2 = None
vp3 = None
vc = None
vc2 = None
vc3 = None
ec = None
earray = None
DAT = None
ECM = None
ECA = None
vcm = None

###################################################


def DetectMap(matrix=DAT):
    """
    Display Detector Map
    @param  matrix [Def:DAT] ElementContainerMatrix Object
    @retval vp3
    """
    return UVM.DetectMap(matrix)

###################################################


def DetectMap2(matrix=DAT):
    """
    Display Detector Map
    @param  matrix [Def:DAT] ElementContainerMatrix Object
    @retval vp3
    """
    return UVM.DetectMap2(matrix)

###################################################


def DetectMap2ChangeData(vp3=vp3, matrix=DAT):
    """
    Display Detector Map
    @param  matrix [Def:DAT] ElementContainerMatrix Object
    @retval vp3
    """
    UVM.DetectMapChangeData(vp3, matrix)

###################################################


def MPlot(ec=ec):
    """
    Create 1D Plotter and Draw EC
    @param  ec [Def:EC]  ElementContainer
    @param  psd      PSD No.
    @param  pixel    Pixel No.
    @retval vp1    Instance of Plotter
    """
    return UVM.MPlot(ec)

###################################################


def AddToMPlot(vp1=vp1, ec=ec):
    """
    Add EC to 1D Plotter
    @param  vp1 [Def:vp1]     Instance of 1D Plotter
    @param  ec [Def:EC]      ElementContainer
    @retval None
    """
    UVM.AddToMPlot(vp1, ec)

###################################################


def EmptyMPlot():
    """
    Create 1D Plotter and Draw EC without data
    @param  None
    @retval vp1 [Def:vp1] Instance of Plotter
    """
    return UVM.MPlot(None)

###################################################


def M2PlotPlus(matrix=ECA):
    """
    Create 2D Plotter and display 2D Map
    @param  matrix [Def:ECM]  ElementContainerArray
    @retval vp2 [Def:vp2]  Instance of 2D Plotter
    """
    return UVM.M2PlotPlus(matrix)

###################################################


def ChangeDataM2Plot(vp2=vp2, matrix=ECA):
    """
    Change 2D Map of M2Plot
    @param  vp2 [Def:vp2]     Instance of 2D Plotter
    @param  matrix [Def:ECA]  ElementContainerArray
    @retval None
    """
    UVM.ChangeDataM2Plot(vp2, matrix)

###################################################


def EmptyM2PlotPlus():
    """
    Create 2D Plotter and display 2D Map without data
    @param  None
    @retval vp2 [Def:vp2]  Instance of 2D Plotter
    """
    return UVM.EmptyM2PlotPlus()


# 関数名登録ディクショナリ
_functions = {"DetectMap": DetectMap,
              "DetectMap2": DetectMap2,
              "DetectMap2ChangeData": DetectMap2ChangeData,
              "MPlot": MPlot,
              "AddToMPlot": AddToMPlot,
              "EmptyMPlot": EmptyMPlot,
              "M2PlotPlus": M2PlotPlus,
              "ChangeDataM2Plot": ChangeDataM2Plot,
              "EmptyM2PlotPlus": EmptyM2PlotPlus,
              }

_functionsOrder = [
    "DetectMap",
    "MPlot",
    "AddToMPlot",
    "EmptyMPlot",
    "M2PlotPlus",
    "ChangeDataM2Plot",
    "EmptyM2PlotPlus",
    "DetectMap2",
    "DetectMap2ChangeData",
]
